/*
 * Author: Utkarsh Gupta
 * Created on: June 5, 2012
 * File Name : IsPrime.cpp
 * Project Name : Automation of Folding (DDP)
 * Description : This function checks the primality for
 *            an interger argument
 */

#include <iostream>
#include <fstream>
#include <string>
#include <math.h>

using namespace std;

bool IsPrime( int number )
{
  int i = 0;
  double limit;
  bool check_prime = false;

  // Test all the factors till the limit of square root of n. At least one
  // factor will be less that, guaranteed.
  limit = ceil(sqrt(number)) + 1;

  if (number % 2 != 0)  // Number is not even, hence possibly prime
  {
    for( i = 3; i < limit; i += 2 ) // Only test for odd factors
    {
      if (number % i == 0)
        break;
    }
  }
  // If no factor less than square root of n is found, means the number is
  // actually a prime number.
  if( i >= limit )
    check_prime = true;

    return (check_prime);
}




