/*
 * Author: Utkarsh Gupta
 * Created on: June 5, 2012
 * File Name : tool_initailize.cpp
 * Project Name : Automation of Folding (DDP)
 * Description : This file stores the user-defined paramaters
 *        (either givern by the user itself of taken from already
 *         written files) in the PG paramters struct
 */

#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include "C_Functions/data_structs.h"
#include "C_Functions/auxiliary_functions.h"

using std::vector;
using namespace std;

void tool_initialize(parameters &PG_parameters)
{
    char sel;
    sel = '\0';
    while (sel != 'f' && sel != 's' )
    {
        cout << "Press 'f' for using a file for Input OR 's' for User-defined Inputs : ";
        cin >> sel;
    }

    if (sel == 'f'){
        ifstream file ("fold_parameters.txt", ios::in);

        //if the file is not open
        if(!file.is_open()){
            cout << "Could not open file fold_parameters.txt !" << endl; //<< inname << "!"<<endl;
            return ;
        }

        int read_int;
        file >> read_int;
        PG_parameters.nodes = read_int;
        file >> read_int;
        PG_parameters.order = read_int;
        int conn_num = 0;
        // Following array stores the list of connection of first node on
        // (some) one side of the bipartite graph.
        PG_parameters.hyp_conn = new int[PG_parameters.order];
        PG_parameters.hyp_conn[0] = 0;
        while(!file.eof())
        {
            file >> read_int;
            PG_parameters.hyp_conn[conn_num] = read_int - PG_parameters.hyp_conn[0];
            conn_num++;
        }
        sort2(PG_parameters.hyp_conn, PG_parameters.order);
        cout << " * PARAMETERS OF THE PG GRAPH FROM FILE\n";
        cout << " *     NODES (Total)\t\t=> " << PG_parameters.nodes  << endl;
        cout << " *     ORDER\t\t\t=> " << PG_parameters.order << endl;
        cout << " *     HYP#0 CONNECTIONS\t=> { ";
        for(int conn = 0; conn < PG_parameters.order - 1; conn++)
            cout << PG_parameters.hyp_conn[conn] <<", ";
        cout << PG_parameters.hyp_conn[PG_parameters.order - 1] <<" }\n\n";
    }
    else if (sel == 's')
    {
        cout << "How many nodes are there on the HYPERPLANE side ? :" ;
        cin >> PG_parameters.nodes;
        cout << "What is the order of the HYPERPLANE Side ? :" ;
        cin >> PG_parameters.order;

        // Following array stores the list of connection of first node on
        // (some) one side of the bipartite graph.
        PG_parameters.hyp_conn = new int[PG_parameters.order];
        PG_parameters.hyp_conn[0] = 0;

        /* These sequence of steps ask the user to input the connections of the
        first node of one side of the Graph.
        Since only this is required to generate all the subsequent connections
        for all the nodes on both sides of the PG Graph
        */
        int usr_ip;
        for(int conn_num = 0; conn_num < PG_parameters.order; conn_num++)
        {
            cout << "Connection# "<< conn_num <<" ? :";
            cin >> usr_ip;
            PG_parameters.hyp_conn[conn_num] = usr_ip - PG_parameters.hyp_conn[0];
        }
        cout << endl << endl;
        sort2(PG_parameters.hyp_conn, PG_parameters.order);
    }

    PG_parameters.point_conn = new int[PG_parameters.order];
    PG_parameters.point_conn[0] = 0;
    for(int conn_num = 0; conn_num < PG_parameters.order; conn_num++)
    {
        PG_parameters.point_conn[conn_num] = (PG_parameters.nodes - PG_parameters.hyp_conn[conn_num]) % PG_parameters.nodes;
    }
    sort2(PG_parameters.point_conn, PG_parameters.order);
    return ;
}







