#include <iostream>
#include <fstream>
#include <cmath>
#include <string.h>
#include <vector>
#include "C_Functions/auxiliary_functions.h"

using namespace std;

void make_seq(int order, int fold_factor){
    int patterns = ((order + (order%2))/2);
    int pattern_bits = bin_digits( patterns - 1);
    int fold_bits = bin_digits( fold_factor - 1);
    int microcode_bits = 31 + 2*fold_bits + 2*pattern_bits ;

    string default_addrZ = "";
    string default_addr0 = "";

    // Preparing default address value if clock is low.
    for(int j = 0; j<bin_digits(microcode_bits); j++)
    {
      default_addrZ += "Z";
      default_addr0 += "0";
    }

    int total_cycles = fold_factor + 4 + fold_factor*patterns + fold_factor + fold_factor*patterns + 4 + fold_factor*patterns + fold_factor*patterns + 2;

    ofstream outfile("Generated_Files/Portions/Sequencer/seq_mid.vhd");

    outfile << "        add       <= \"" << default_addrZ << "\";\n";
    outfile << "        addrcount <= 0;\n";
    outfile << "    ELSIF (clock'event AND clock='1') THEN\n";
    outfile << "      IF en_seq = '1' THEN\n";
    outfile << "        IF (addrcount = " << total_cycles - 1 <<") THEN\n";
    outfile << "          addrcount <= " << fold_factor <<";\n";
    outfile << "        ELSE\n";
    outfile << "          addrcount <= addrcount + 1;\n";
    outfile << "        END IF;\n";
    outfile << "      ELSE\n";
    outfile << "        add       <= \"" << default_addr0 << "\";\n";
    outfile << "        addrcount <= 0;\n";
    outfile << "      END IF;\n";
    outfile << "      add <= CONV_STD_LOGIC_VECTOR( addrcount, " << bin_digits(microcode_bits) << " );";

    outfile.close();

    outfile.open("HDL_Final_Modules/microcode_seq.vhd");
    outfile.close();

    append( "HDL_partitioned_files/Sequencer/seq_start.vhd", "HDL_Final_Modules/microcode_seq.vhd");
    append( "Generated_Files/Portions/Sequencer/seq_mid.vhd", "HDL_Final_Modules/microcode_seq.vhd");
    append( "HDL_partitioned_files/Sequencer/seq_end.vhd", "HDL_Final_Modules/microcode_seq.vhd");

    return;
}
