/*
 * Author: Utkarsh Gupta
 * Created on: June 5, 2012
 * File Name : auxiliary_functions.cpp
 * Project Name : Automation of Folding (DDP)
 * Description : This file contains the auxiliary functions
 *            that by the tool functions.
 */


#include <iostream>
#include <fstream>
#include <cmath>
#include <string.h>
#include <vector>

using std::vector;
using namespace std;

void sort( std::vector<int> numbers, int count )
{
    int i, j;
    int temp;
    do{
        j = 0;
        for (i = 0; i<count-1; i++){
                if (numbers[i] > numbers[i+1]){//this was numbers[k], which was an error
                    j = 1;
                    temp = numbers[i];
                    numbers[i] = numbers[i+1];
                    numbers[i+1] = temp;
                }
            }
    } while (j == 1);
}

void sort2( int *numbers, int count )
{
    int i, j;
    int temp;
    do{
        j = 0;
        for (i = 0; i<count-1; i++){
                if (numbers[i] > numbers[i+1]){//this was numbers[k], which was an error
                    j = 1;
                    temp = numbers[i];
                    numbers[i] = numbers[i+1];
                    numbers[i+1] = temp;
                }
            }
    } while (j == 1);
}

void append(const char * inputfile, const char * outputfile)
{
    long size_o, size_i;
    char *buffer1, *buffer2;

    ifstream infile;

    infile.open (inputfile, ifstream::in);
    infile.seekg(0,ifstream::end);
    size_i = infile.tellg();
    infile.seekg(0);
    buffer1 = new char [size_i];
    infile.read (buffer1, size_i);

    infile.close();

    infile.open (outputfile, ifstream::in);
    infile.seekg(0,ifstream::end);
    size_o = infile.tellg();
    infile.seekg(0);
    buffer2 = new char [size_o];
    infile.read (buffer2,size_o);

    infile.close();

    ofstream outfile;
    outfile.open (outputfile);
    outfile.write (buffer2,size_o);
    outfile.write (buffer1,size_i);
    delete[] buffer1;
    delete[] buffer2;
    outfile.close();

    return;
}

int exp(int k, int a) // k^a calculation
{
    int x = 1;

    for(int i = 0; i<a; i++)
    {
      x  *= k;

    }
    return x;
}

int bin_digits(int a) // finds the number of binary digits needed to
                      // represent 'a' in binary
{
    int count_a = 1;

    while(a >= exp(2,count_a))
    {
      count_a++;
    }
    return count_a;
}

string binary(const int& number, const int& length_num) //
{
    string bin;

    int q = number, count_num = 1, count_rep_len = 1;
    while(number >= exp(2,count_num))
      count_num++;

    while(length_num >= exp(2,count_rep_len))
      count_rep_len++;

    while(q >= 2)
    {
      if(q%2 == 1)
      {
        bin = "1"+bin;
      }
      else
      {
        bin = "0"+bin;
      }
      q = q/2;
    }

    bin = "1"+bin;
    if(number == 0)
    {
      count_num = 0; bin = "";
    }

    int x = ( count_rep_len - count_num );

    for(int i = 0; i<x; i++)
    {
      bin = "0"+bin;
    }

    return bin;
}

// This function is going to be used for selecting the
//appropriate lines in MUX and DEMUX module
//
int select_line(int edge_conn[], int num_edges, int id, int folded_nodes, int line_sel_val, int line_sel_num)
{
    int *temp_edge_conn= new int[num_edges];
    for ( int edge_no = 0; edge_no < num_edges; edge_no++)
    {
        temp_edge_conn[edge_no] = (edge_conn[edge_no] + id)%folded_nodes;
    }
    //sort(temp_edge_conn, num_edges);
    int i, j;
    int temp;
    int count = num_edges;
    do{
        j = 0;
        for (i = 0; i<count-1; i++){
                if (temp_edge_conn[i] > temp_edge_conn[i+1]){
                    j = 1;
                    temp = temp_edge_conn[i];
                    temp_edge_conn[i] = temp_edge_conn[i+1];
                    temp_edge_conn[i+1] = temp;
                }
            }
    } while (j == 1);

    int found = 0;
    int found_index1 = -1;
    int found_index2 = -1;
    for ( int edge_no = 0; edge_no < num_edges; edge_no++)
    {
        if(temp_edge_conn[edge_no] == line_sel_val){
            found = found + 1;
            if (found == 1)
                found_index1 = edge_no;
            else if (found == 2)
                found_index2 = edge_no;
        }
    }

    int ret;
    if ( found == 1 )
        ret =  found_index1;
    else {
        if ( line_sel_num == 1){
            ret =  found_index1;
        }
        else if ( line_sel_num == 2){
            ret = found_index2;
        }
    }

    return ret;
}



// Auxiliary functions for making the microcode
/*     This functions fills the Array 'array' with 'num_to_fill'
    starting at the Index 'start' upto 'length' number of indices */
void fill_array( int *array, int start, int length, int num_to_fill ){
    for( int array_index = start; array_index < start + length ; array_index++){
        array[array_index] = num_to_fill;
    }
    return;
}

/*    This functions fills the Array 'array' with sequence of natural numbers in Period
     'period' starting at the Index 'start' upto 'length' number of indices */
void fill_seq( int *array, int start, int length, int period){
    int seq_num = 0;
    for( int array_index = start; array_index < start + length ; array_index++){
        array[array_index] = seq_num;
        if ( seq_num == period - 1)
            seq_num = 0;
        else
            seq_num++;
    }
    return;
}

void fill_seq2( int **array, int start, int length, int period, int start_index, int size){
    int seq_num = 0;
    for( int i = start; i < start + length ; i++){
        for( int j = start_index; j < start_index + size ; j++){
            array[j][i] = (seq_num/exp(2,(j-start_index)))%2;
        }
        if ( seq_num == period - 1)
            seq_num = 0;
        else
            seq_num++;
    }
    return;
}

void fill_seq3( int **array, int start, int length, int period, int start_index, int size){
    int* seq_num = new int [size];
    int seq_ctr = 0;
    int pre_carry;
    for( int x = 0; x < size ; x++)
        seq_num[x] = 0;

    for( int i = start; i < start + length ; i++){
        for( int j = start_index; j < start_index + size ; j++){
            array[j][i] = seq_num[j - start_index];
        }
        if ( seq_ctr == period - 1){
            seq_ctr = 0;
            pre_carry = 1;
            for( int x = 0; x < size ; x++){
                if ( pre_carry == 1){
                    if(seq_num[x] == 1)
                        seq_num[x] = 0;
                    else if (seq_num[x] == 0){
                        seq_num[x] = 1;
                        pre_carry = 0;
                    }
                }
                else{
                    break;
                }
            }
        }
        else
            seq_ctr++;
    }
    return;
}
