LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE WORK.fold_package.ALL;

ENTITY add_mux IS
    PORT ( clk          : IN STD_LOGIC;
           in_r_addr    : IN mem_addr_bus;
           in_w_addr    : IN mem_addr_bus;
           rd_w_bar     : IN STD_LOGIC;
           en           : IN STD_LOGIC;
           out_addr     : OUT mem_addr_bus
         );
END ENTITY add_mux;

ARCHITECTURE behav OF add_mux IS
BEGIN

-- Let the address get multiplexed half a cycle later after its
-- generation, so that it can be used up by the memory in next cycle
-- itself.
PROCESS( clk )
BEGIN
    IF( clk'event AND clk='0' ) THEN
      IF( en = '1' ) THEN
        IF( rd_w_bar = '1' ) THEN    -- Read address passes through
          out_addr <= in_r_addr;
        ELSIF( rd_w_bar = '0' ) THEN -- Write address passes through
          out_addr <= in_w_addr;
        END IF;
      ELSE
        out_addr
 <= "ZZZZZ";
      END IF;
    END IF;
END PROCESS;

END ARCHITECTURE behav;
