LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;  -- CONV_STD_LOGIC_VECTOR( )
USE WORK.fold_package.ALL;

ENTITY rd_addrgen IS
        PORT ( clk          : IN STD_LOGIC;
               en_addrgen   : IN STD_LOGIC;
               addr1        : OUT mem_addr_bus;
               addr2        : OUT mem_addr_bus
             );
END ENTITY rd_addrgen;

ARCHITECTURE behav OF rd_addrgen IS
    SIGNAL count1, count2 : INTEGER;  -- address counters
    SIGNAL addrcount      : INTEGER;  -- loop counter
BEGIN

    a1: addr1     <= "ZZZZZ";
    a2: addr2     <= "ZZZZZ";

PROCESS( clk )
BEGIN
    IF(clk'event and clk='1') THEN
      IF en_addrgen /= '1' THEN
        count1    <= 0;
        count2    <= 1;
        addrcount <= 1;
      ELSIF en_addrgen = '1' THEN
        IF (addrcount = no_unfolded_pap*fold_factor ) THEN

            addr1     <= CONV_STD_LOGIC_VECTOR( count1, 5 );
            addr2     <= CONV_STD_LOGIC_VECTOR( count2, 5 );
          count1    <= 0;
          count2    <= 1;
          addrcount <= 1;
        ELSE

            addr1     <= CONV_STD_LOGIC_VECTOR( count1, 5 );
            addr2     <= CONV_STD_LOGIC_VECTOR( count2, 5 );
          count1    <= count1 + 2;
          count2    <= count2 + 2;
          addrcount <= addrcount + 1;
        END IF;
      ELSE

        addr1     <= "00000";
        addr2     <= "00000";
        addrcount   <= 1;
      END IF;
    END IF;
END PROCESS;

END ARCHITECTURE behav;
