LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;  -- CONV_STD_LOGIC_VECTOR( )
USE WORK.fold_package.ALL;

ENTITY hyp_wr_addrgen IS
        PORT ( clk          : IN STD_LOGIC;
               en_addrgen   : IN STD_LOGIC;
               mu_id        : IN node_indx;
               addr1        : OUT mem_addr_bus;
               addr2        : OUT mem_addr_bus
             );
END ENTITY hyp_wr_addrgen;

ARCHITECTURE behav OF hyp_wr_addrgen IS
    SIGNAL count1, count2 : INTEGER;  -- address counters
    SIGNAL addrcount      : INTEGER;  -- loop counter

CONSTANT wr_tab_1 : wr_addr_list := ( 0, 19, 2, 21, 4, 23, 18, 13, 20, 15, 22, 17, 12, 7, 14, 9, 16, 11, 6, 1, 8, 3, 10, 5 );
CONSTANT wr_tab_2 : wr_addr_list := ( 0, 19, 2, 21, 4, 23, 18, 13, 20, 15, 22, 17, 12, 7, 14, 9, 16, 11, 6, 1, 8, 3, 10, 5 );
CONSTANT wr_tab_3 : wr_addr_list := ( 0, 19, 2, 21, 4, 23, 18, 13, 20, 15, 22, 17, 12, 7, 14, 9, 16, 11, 6, 1, 8, 3, 10, 5 );
CONSTANT wr_tab_4 : wr_addr_list := ( 0, 19, 2, 21, 4, 23, 18, 13, 20, 15, 22, 17, 12, 7, 14, 9, 16, 11, 6, 1, 8, 3, 10, 5 );
CONSTANT wr_tab_5 : wr_addr_list := ( 0, 19, 2, 21, 4, 23, 18, 13, 20, 15, 22, 17, 12, 7, 14, 9, 16, 11, 6, 1, 8, 3, 10, 5 );
CONSTANT wr_tab_6 : wr_addr_list := ( 0, 19, 2, 21, 4, 23, 18, 13, 20, 15, 22, 17, 12, 7, 14, 9, 16, 11, 6, 3, 8, 5, 10, 1 );
CONSTANT wr_tab_7 : wr_addr_list := ( 0, 19, 2, 21, 4, 23, 18, 13, 20, 15, 22, 17, 12, 7, 14, 9, 16, 11, 6, 3, 8, 5, 10, 1 );
CONSTANT wr_tab_8 : wr_addr_list := ( 0, 19, 2, 21, 4, 23, 18, 13, 20, 15, 22, 17, 12, 7, 14, 9, 16, 11, 6, 3, 8, 5, 10, 1 );
CONSTANT wr_tab_9 : wr_addr_list := ( 0, 19, 2, 21, 4, 23, 18, 13, 20, 15, 22, 17, 12, 7, 14, 9, 16, 11, 6, 3, 8, 5, 10, 1 );
CONSTANT wr_tab_10 : wr_addr_list := ( 0, 19, 2, 21, 4, 23, 18, 13, 20, 15, 22, 17, 12, 7, 14, 9, 16, 11, 8, 3, 10, 5, 6, 1 );
CONSTANT wr_tab_11 : wr_addr_list := ( 0, 19, 2, 21, 4, 23, 18, 13, 20, 15, 22, 17, 12, 7, 14, 9, 16, 11, 8, 3, 10, 5, 6, 1 );
CONSTANT wr_tab_12 : wr_addr_list := ( 0, 19, 2, 21, 4, 23, 18, 13, 20, 15, 22, 17, 12, 9, 14, 11, 16, 7, 8, 3, 10, 5, 6, 1 );
CONSTANT wr_tab_13 : wr_addr_list := ( 0, 19, 2, 21, 4, 23, 18, 13, 20, 15, 22, 17, 12, 9, 14, 11, 16, 7, 8, 3, 10, 5, 6, 1 );
CONSTANT wr_tab_14 : wr_addr_list := ( 0, 19, 2, 21, 4, 23, 18, 13, 20, 15, 22, 17, 12, 9, 14, 11, 16, 7, 8, 3, 10, 5, 6, 1 );
CONSTANT wr_tab_15 : wr_addr_list := ( 0, 19, 2, 21, 4, 23, 18, 13, 20, 15, 22, 17, 14, 9, 16, 11, 12, 7, 8, 3, 10, 5, 6, 1 );
CONSTANT wr_tab_16 : wr_addr_list := ( 0, 19, 2, 21, 4, 23, 18, 15, 20, 17, 22, 13, 14, 9, 16, 11, 12, 7, 8, 3, 10, 5, 6, 1 );
CONSTANT wr_tab_17 : wr_addr_list := ( 0, 19, 2, 21, 4, 23, 18, 15, 20, 17, 22, 13, 14, 9, 16, 11, 12, 7, 8, 3, 10, 5, 6, 1 );
CONSTANT wr_tab_18 : wr_addr_list := ( 0, 19, 2, 21, 4, 23, 20, 15, 22, 17, 18, 13, 14, 9, 16, 11, 12, 7, 8, 3, 10, 5, 6, 1 );
CONSTANT wr_tab_19 : wr_addr_list := ( 0, 21, 2, 23, 4, 19, 20, 15, 22, 17, 18, 13, 14, 9, 16, 11, 12, 7, 8, 3, 10, 5, 6, 1 );
BEGIN

    a1: addr1     <= "ZZZZZ";
    a2: addr2     <= "ZZZZZ";
PROCESS( clk )
    BEGIN
        IF(clk'event and clk='1') THEN
          IF en_addrgen /= '1' THEN -- Keep the counters in check.
            addrcount <= 0;
          ELSIF en_addrgen = '1' THEN
            IF( mu_id = "00000" ) THEN
              addr1 <= CONV_STD_LOGIC_VECTOR( wr_tab_1( addrcount ), 5 );
              addr2 <= CONV_STD_LOGIC_VECTOR( wr_tab_1( addrcount + 1 ), 5 );
            ELSIF( mu_id = "00001" ) THEN
              addr1 <= CONV_STD_LOGIC_VECTOR( wr_tab_2( addrcount ), 5 );
              addr2 <= CONV_STD_LOGIC_VECTOR( wr_tab_2( addrcount + 1 ), 5 );
            ELSIF( mu_id = "00010" ) THEN
              addr1 <= CONV_STD_LOGIC_VECTOR( wr_tab_3( addrcount ), 5 );
              addr2 <= CONV_STD_LOGIC_VECTOR( wr_tab_3( addrcount + 1 ), 5 );
            ELSIF( mu_id = "00011" ) THEN
              addr1 <= CONV_STD_LOGIC_VECTOR( wr_tab_4( addrcount ), 5 );
              addr2 <= CONV_STD_LOGIC_VECTOR( wr_tab_4( addrcount + 1 ), 5 );
            ELSIF( mu_id = "00100" ) THEN
              addr1 <= CONV_STD_LOGIC_VECTOR( wr_tab_5( addrcount ), 5 );
              addr2 <= CONV_STD_LOGIC_VECTOR( wr_tab_5( addrcount + 1 ), 5 );
            ELSIF( mu_id = "00101" ) THEN
              addr1 <= CONV_STD_LOGIC_VECTOR( wr_tab_6( addrcount ), 5 );
              addr2 <= CONV_STD_LOGIC_VECTOR( wr_tab_6( addrcount + 1 ), 5 );
            ELSIF( mu_id = "00110" ) THEN
              addr1 <= CONV_STD_LOGIC_VECTOR( wr_tab_7( addrcount ), 5 );
              addr2 <= CONV_STD_LOGIC_VECTOR( wr_tab_7( addrcount + 1 ), 5 );
            ELSIF( mu_id = "00111" ) THEN
              addr1 <= CONV_STD_LOGIC_VECTOR( wr_tab_8( addrcount ), 5 );
              addr2 <= CONV_STD_LOGIC_VECTOR( wr_tab_8( addrcount + 1 ), 5 );
            ELSIF( mu_id = "01000" ) THEN
              addr1 <= CONV_STD_LOGIC_VECTOR( wr_tab_9( addrcount ), 5 );
              addr2 <= CONV_STD_LOGIC_VECTOR( wr_tab_9( addrcount + 1 ), 5 );
            ELSIF( mu_id = "01001" ) THEN
              addr1 <= CONV_STD_LOGIC_VECTOR( wr_tab_10( addrcount ), 5 );
              addr2 <= CONV_STD_LOGIC_VECTOR( wr_tab_10( addrcount + 1 ), 5 );
            ELSIF( mu_id = "01010" ) THEN
              addr1 <= CONV_STD_LOGIC_VECTOR( wr_tab_11( addrcount ), 5 );
              addr2 <= CONV_STD_LOGIC_VECTOR( wr_tab_11( addrcount + 1 ), 5 );
            ELSIF( mu_id = "01011" ) THEN
              addr1 <= CONV_STD_LOGIC_VECTOR( wr_tab_12( addrcount ), 5 );
              addr2 <= CONV_STD_LOGIC_VECTOR( wr_tab_12( addrcount + 1 ), 5 );
            ELSIF( mu_id = "01100" ) THEN
              addr1 <= CONV_STD_LOGIC_VECTOR( wr_tab_13( addrcount ), 5 );
              addr2 <= CONV_STD_LOGIC_VECTOR( wr_tab_13( addrcount + 1 ), 5 );
            ELSIF( mu_id = "01101" ) THEN
              addr1 <= CONV_STD_LOGIC_VECTOR( wr_tab_14( addrcount ), 5 );
              addr2 <= CONV_STD_LOGIC_VECTOR( wr_tab_14( addrcount + 1 ), 5 );
            ELSIF( mu_id = "01110" ) THEN
              addr1 <= CONV_STD_LOGIC_VECTOR( wr_tab_15( addrcount ), 5 );
              addr2 <= CONV_STD_LOGIC_VECTOR( wr_tab_15( addrcount + 1 ), 5 );
            ELSIF( mu_id = "01111" ) THEN
              addr1 <= CONV_STD_LOGIC_VECTOR( wr_tab_16( addrcount ), 5 );
              addr2 <= CONV_STD_LOGIC_VECTOR( wr_tab_16( addrcount + 1 ), 5 );
            ELSIF( mu_id = "10000" ) THEN
              addr1 <= CONV_STD_LOGIC_VECTOR( wr_tab_17( addrcount ), 5 );
              addr2 <= CONV_STD_LOGIC_VECTOR( wr_tab_17( addrcount + 1 ), 5 );
            ELSIF( mu_id = "10001" ) THEN
              addr1 <= CONV_STD_LOGIC_VECTOR( wr_tab_18( addrcount ), 5 );
              addr2 <= CONV_STD_LOGIC_VECTOR( wr_tab_18( addrcount + 1 ), 5 );
            ELSIF( mu_id = "10010" ) THEN
              addr1 <= CONV_STD_LOGIC_VECTOR( wr_tab_19( addrcount ), 5 );
              addr2 <= CONV_STD_LOGIC_VECTOR( wr_tab_19( addrcount + 1 ), 5 );
            END IF;
            addrcount <= addrcount + 2;
          END IF;
        END IF;
END PROCESS;

END ARCHITECTURE behav;
