LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE WORK.fold_package.ALL;

ENTITY check_f_unit IS
    PORT( clk           : IN STD_LOGIC;
          rst_c         : IN STD_LOGIC;
          in_bit1       : IN STD_LOGIC;
          in_bit2       : IN STD_LOGIC;
          en_check      : IN STD_LOGIC;
          en_out        : IN STD_LOGIC;
          fold_indx     : IN fold_indx;
          out_res1      : OUT STD_LOGIC;
          out_res2      : OUT STD_LOGIC
        );
END ENTITY check_f_unit;

ARCHITECTURE behav OF check_f_unit IS
    SIGNAL
check_res0, check_res1, check_res2   : STD_LOGIC;
BEGIN

-- Accmulate the parity at max 2 input bits at a time.
PROCESS( clk )
BEGIN
    IF( rst_c = '1' ) THEN
      check_res0     <= '0';
      check_res1     <= '0';
      check_res2     <= '0';
    ELSE
      IF(clk'event and clk='1') THEN
        IF( en_check = '1' ) THEN
          IF( fold_indx = "00" ) THEN
            IF( is_deg_odd = TRUE AND ( in_bit2 = '0' OR in_bit2 = '1' ) ) THEN
              check_res0 <= check_res0 XOR in_bit1 XOR in_bit2;
            ELSE
              check_res0 <= check_res0 XOR in_bit1;
            END IF;
          ELSIF( fold_indx = "01" ) THEN
            IF( is_deg_odd = TRUE AND ( in_bit2 = '0' OR in_bit2 = '1' ) ) THEN
              check_res1 <= check_res1 XOR in_bit1 XOR in_bit2;
            ELSE
              check_res1 <= check_res1 XOR in_bit1;
            END IF;
          ELSIF( fold_indx = "10" ) THEN
            IF( is_deg_odd = TRUE AND ( in_bit2 = '0' OR in_bit2 = '1' ) ) THEN
              check_res2 <= check_res2 XOR in_bit1 XOR in_bit2;
            ELSE
              check_res2 <= check_res2 XOR in_bit1;
            END IF;
          END IF;
        END IF;
      END IF;
    END IF;
END PROCESS;

-- Send out the checking result at appropriate time.
PROCESS( clk )
BEGIN
    IF(clk'event and clk='1') THEN
      IF( en_out = '1' ) THEN
        IF( fold_indx = "00" ) THEN
          out_res1 <= check_res0;
          out_res2 <= check_res0;
        ELSIF( fold_indx = "01" ) THEN
          out_res1 <= check_res1;
          out_res2 <= check_res1;
        ELSIF( fold_indx = "10" ) THEN
          out_res1 <= check_res2;
          out_res2 <= check_res2;
        END IF;
      END IF;
    END IF;

END PROCESS;

END ARCHITECTURE behav;
