LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE WORK.fold_package.ALL;

ENTITY p_2_h_rom IS
    PORT( pat_id : IN pat_indx;
          out1   : OUT rom_sel_bus;
          out2   : OUT rom_sel_bus
        );
END ENTITY p_2_h_rom;

ARCHITECTURE behav OF p_2_h_rom IS
BEGIN

PROCESS( pat_id )
BEGIN
    -- Output first line selection/line address
    CASE pat_id IS
        WHEN "00"   => out1 <= "00000"; -- 0
        WHEN "01"   => out1 <= "00010"; -- 2
        WHEN "10"   => out1 <= "00101"; -- 5
        WHEN "11"   => out1 <= "01010"; -- 10
        WHEN OTHERS => out1 <= "ZZZZZ";
    END CASE;

    -- Output second line selection/line address
    CASE pat_id IS
        WHEN "00"   => out2 <= "00001";-- 1
        WHEN "01"   => out2 <= "00100";-- 4
        WHEN "10"   => out2 <= "01000";-- 8
        WHEN "11"   => out2 <= "01110";
        WHEN OTHERS => out1 <= "ZZZZZ";
    END CASE;


END PROCESS;

END ARCHITECTURE behav;
