LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE WORK.fold_package.ALL;

ENTITY h_2_p_rom IS
    PORT( pat_id : IN pat_indx;
          out1   : OUT rom_sel_bus;
          out2   : OUT rom_sel_bus
        );
END ENTITY h_2_p_rom;

ARCHITECTURE behav OF h_2_p_rom IS
BEGIN

PROCESS( pat_id )
BEGIN
    -- Output first line selection/line address
    CASE pat_id IS
        WHEN "00"   => out1 <= "00000"; -- 0
        WHEN "01"   => out1 <= "01001"; -- 47
        WHEN "10"   => out1 <= "01110"; -- 52
        WHEN "11"   => out1 <= "10001"; -- 55
        WHEN OTHERS => out1 <= "ZZZZZ";
    END CASE;

    -- Output second line selection/line address
    CASE pat_id IS
        WHEN "00"   => out2 <= "00101";-- 43
        WHEN "01"   => out2 <= "01011";-- 49
        WHEN "10"   => out2 <= "01111";-- 53
        WHEN "11"   => out2 <= "10010";
        WHEN OTHERS => out1 <= "ZZZZZ";
    END CASE;


END PROCESS;

END ARCHITECTURE behav;
