LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE WORK.fold_package.ALL;

ENTITY sequencer IS
PORT( clock   : IN STD_LOGIC;
      en_seq  : IN STD_LOGIC;
      add     : OUT addr_bus
    );
END ENTITY sequencer;

ARCHITECTURE behav OF sequencer IS
    SIGNAL addrcount: INTEGER;   -- counter
BEGIN

PROCESS(clock, en_seq)
BEGIN
    IF en_seq /= '1' THEN
        add       <= "ZZZZZZ";
        addrcount <= 0;
    ELSIF (clock'event AND clock='1') THEN
      IF en_seq = '1' THEN
        IF (addrcount = 63) THEN
          addrcount <= 3;
        ELSE
          addrcount <= addrcount + 1;
        END IF;
      ELSE
        add       <= "000000";
        addrcount <= 0;
      END IF;
      add <= CONV_STD_LOGIC_VECTOR( addrcount, 6 );
    END IF;
END PROCESS;

END ARCHITECTURE behav;
