LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

PACKAGE fold_package IS

    TYPE wr_addr_list             IS ARRAY ( 0 to 23 ) OF INTEGER;
    TYPE bus_instr_in             IS ARRAY ( 0 to 56 ) OF STD_LOGIC_VECTOR( 8 DOWNTO 0 );
    TYPE bus_fold_instr_in        IS ARRAY ( 0 to 18 ) OF STD_LOGIC_VECTOR( 8 DOWNTO 0 );
    TYPE def_network              IS ARRAY ( 151 DOWNTO 0 ) OF STD_LOGIC;
    TYPE x_network                IS ARRAY ( 151 DOWNTO 0 ) OF STD_LOGIC;
    SUBTYPE out_bus             IS STD_LOGIC_VECTOR( 56 DOWNTO 0 );
    SUBTYPE bus_instr_vec         IS STD_LOGIC_VECTOR( 8 DOWNTO 0 );
    SUBTYPE fold_indx             IS STD_LOGIC_VECTOR( 1 DOWNTO 0 );
    SUBTYPE node_indx             IS STD_LOGIC_VECTOR( 4 DOWNTO 0 );
    SUBTYPE pat_indx             IS STD_LOGIC_VECTOR( 1 DOWNTO 0 );
    SUBTYPE microcode_bus        IS STD_LOGIC_VECTOR( 38 DOWNTO 0 );
    SUBTYPE mem_addr_bus        IS STD_LOGIC_VECTOR( 4 DOWNTO 0 );
    SUBTYPE rom_sel_bus            IS STD_LOGIC_VECTOR( 4 DOWNTO 0 );
    SUBTYPE addr_bus             IS STD_LOGIC_VECTOR( 5 DOWNTO 0 );
    SUBTYPE rxvd_fold_bus         IS STD_LOGIC_VECTOR( 18 DOWNTO 0 );
    SUBTYPE procinpbus            IS STD_LOGIC_VECTOR( 18 DOWNTO 0 );
    CONSTANT no_unfolded_pap   : INTEGER     := 4;
    CONSTANT fold_factor     : INTEGER     := 3;
    CONSTANT is_deg_odd      : BOOLEAN     := FALSE;

END PACKAGE fold_package;
