LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE WORK.fold_package.ALL;

ENTITY fold_pg_decoder IS
    PORT( clk           : IN STD_LOGIC;
          en_decode     : IN STD_LOGIC;
          intr_in       : IN bus_instr_in;
          valid_cword   : OUT STD_LOGIC;
          no_iter       : OUT INTEGER;
          output        : OUT out_bus
        );
END ENTITY fold_pg_decoder;

ARCHITECTURE Behavioral OF fold_pg_decoder IS

---------------------bit node component-----------------------

COMPONENT bit_f_unit
    PORT( clk            : IN STD_LOGIC;
          in_bit1        : IN STD_LOGIC;
          in_bit2        : IN STD_LOGIC;
          intrinsic_vec  : IN bus_instr_vec;
          fold_indx      : IN fold_indx;
          en_acc         : IN STD_LOGIC;
          en_flip        : IN STD_LOGIC;
          en_first_time  : IN STD_LOGIC;
          en_part_store  : IN STD_LOGIC;
          en_count_reset : IN STD_LOGIC;
          en_out         : IN STD_LOGIC;
          bit_estimate   : OUT STD_LOGIC;
          out_bit1       : OUT STD_LOGIC;
          out_bit2       : OUT STD_LOGIC
        );
END COMPONENT;

--------------------check node component----------------------

COMPONENT check_f_unit
    PORT( clk           : IN STD_LOGIC;
          rst_c         : IN STD_LOGIC;
          in_bit1       : IN STD_LOGIC;
          in_bit2       : IN STD_LOGIC;
          en_check      : IN STD_LOGIC;
          en_out        : IN STD_LOGIC;
          fold_indx     : IN fold_indx;
          out_res1      : OUT STD_LOGIC;
          out_res2      : OUT STD_LOGIC
        );
END COMPONENT;

--------------------memory unit component---------------------

COMPONENT hyp_mem_unit
    PORT ( clk       : IN STD_LOGIC;
           rst       : IN STD_LOGIC;
           en_use    : IN STD_LOGIC;
           rd_w_bar1 : IN STD_LOGIC;
           rd_w_bar2 : IN STD_LOGIC;
           mu_id     : IN node_indx;
           d_in1     : IN STD_LOGIC;
           d_in2     : IN STD_LOGIC;
           d_out1    : OUT STD_LOGIC;
           d_out2    : OUT STD_LOGIC
         );
END COMPONENT;

COMPONENT point_mem_unit
    PORT ( clk       : IN STD_LOGIC;
           rst       : IN STD_LOGIC;
           en_use    : IN STD_LOGIC;
           rd_w_bar1 : IN STD_LOGIC;
           rd_w_bar2 : IN STD_LOGIC;
           mu_id     : IN node_indx;
           d_in1     : IN STD_LOGIC;
           d_in2     : IN STD_LOGIC;
           d_out1    : OUT STD_LOGIC;
           d_out2    : OUT STD_LOGIC
         );
END COMPONENT;
