
------------------control store component---------------------

COMPONENT control_store
    PORT( addr  : IN addr_bus;
          dout  : OUT microcode_bus
        );
END COMPONENT;

-------------Sequence generator for microcodes----------------

COMPONENT sequencer
    PORT( clock  : IN STD_LOGIC;
          en_seq : IN STD_LOGIC;
          add    : OUT addr_bus
        );
END COMPONENT;

FOR ALL:bit_f_unit      USE ENTITY WORK.bit_f_unit( behav );
FOR ALL:check_f_unit    USE ENTITY WORK.check_f_unit( behav );
FOR ALL:hyp_mem_unit    USE ENTITY WORK.hyp_mem_unit( behav );
FOR ALL:point_mem_unit  USE ENTITY WORK.point_mem_unit( behav );
FOR ALL:h_p_switch      USE ENTITY WORK.h_p_switch( behav );
FOR ALL:p_p_switch      USE ENTITY WORK.p_p_switch( behav );
FOR ALL:h_m_switch      USE ENTITY WORK.h_m_switch( behav );
FOR ALL:p_m_switch      USE ENTITY WORK.p_m_switch( behav );
FOR ALL:control_store   USE ENTITY WORK.control_store( behav );
FOR ALL:sequencer       USE ENTITY WORK.sequencer( behav );

------------------memory signals------------
-- Signals related to memories for bit nodes

SIGNAL en_bmem_use      : STD_LOGIC;
SIGNAL rst_b            : STD_LOGIC;
SIGNAL en_bmem_rd_wbar1 : STD_LOGIC;
SIGNAL en_bmem_rd_wbar2 : STD_LOGIC;
SIGNAL en_m_switch_b    : STD_LOGIC;
SIGNAL en_p_switch_b    : STD_LOGIC;
SIGNAL pat_id_b         : pat_indx;

SIGNAL bmu_in1           : procinpbus;
SIGNAL bmu_in2           : procinpbus;
SIGNAL bmu_out1          : procinpbus;
SIGNAL bmu_out2          : procinpbus;

-- Signals related to memories for check nodes

SIGNAL en_cmem_use      : STD_LOGIC;
SIGNAL rst_c            : STD_LOGIC;
SIGNAL en_cmem_rd_wbar1 : STD_LOGIC;
SIGNAL en_cmem_rd_wbar2 : STD_LOGIC;
SIGNAL en_m_switch_c    : STD_LOGIC;
SIGNAL en_p_switch_c    : STD_LOGIC;
SIGNAL pat_id_c         : pat_indx;
SIGNAL fold_intr_in     : bus_fold_instr_in;

SIGNAL cmu_in1           : procinpbus;
SIGNAL cmu_in2           : procinpbus;
SIGNAL cmu_out1          : procinpbus;
SIGNAL cmu_out2          : procinpbus;

------------------validity check signal----------------
SIGNAL num_of_iter        : INTEGER;

------------------interconnect network------------------
SIGNAL b_to_c_wires       : def_network;
SIGNAL c_to_b_wires       : x_network;

------------------mmux signals--------------------------
SIGNAL en_mmux_b          : STD_LOGIC;
SIGNAL en_mmux_c          : STD_LOGIC;

------------------pmux signals--------------------------
SIGNAL en_pmux_b          : STD_LOGIC;
SIGNAL en_pmux_c          : STD_LOGIC;

------------------bit node signals----------------------
SIGNAL fold_indx_b      : fold_indx;
SIGNAL en_acc_b         : STD_LOGIC;
SIGNAL en_flip_b        : STD_LOGIC;
SIGNAL en_first_time_b  : STD_LOGIC;
SIGNAL en_part_store_b  : STD_LOGIC;
SIGNAL en_count_reset_b : STD_LOGIC;
SIGNAL en_out_b         : STD_LOGIC;

SIGNAL bfu_in1          : procinpbus;
SIGNAL bfu_in2          : procinpbus;
SIGNAL unused_b         : procinpbus;


-------------------check node signals-------------------
SIGNAL en_check_c   : STD_LOGIC;
SIGNAL en_out_c     : STD_LOGIC;
SIGNAL fold_indx_c  : fold_indx;

SIGNAL cfu_in1          : procinpbus;
SIGNAL cfu_in2          : procinpbus;
SIGNAL unused_c         : procinpbus;

---------Control microcodes sequencing signals---------
SIGNAL en_mem             : STD_LOGIC;
SIGNAL en_sequencing      : STD_LOGIC;
SIGNAL microcode          : microcode_bus;
SIGNAL ctrl_store_addr    : addr_bus;

SIGNAL valid_word         : STD_LOGIC;
SIGNAL decide_cword       : STD_LOGIC;
SIGNAL rxvd_code          : out_bus;
SIGNAL pcheck_out         : out_bus;
SIGNAL rxvd_fold          : rxvd_fold_bus;

