/*
 * Author: Utkarsh Gupta
 * Created on: June 5, 2012
 * File Name : tool2.cpp
 * Project Name : Automation of Folding (DDP)
 * Description : This file is the topmost file containing
 *         the main function. With this file the user can input
 *         parameters for the Bipartite PG Graph and use them to
 *         generate the FOLDED PG Graph Modules
 */

#include <iostream>
#include <fstream>
#include <string>
#include "C_Functions/data_structs.h"
#include "C_Functions/Refinement_1/refinement1.h"
#include "C_Functions/Refinement_2/refinement2.h"
#include "C_Functions/Refinement_4/write_vhdl_modules.h"

using namespace std;

int main(int argc , char **argv)
{
    parameters PG_parameters;

    /* REFINEMENT 1
     * This is to get the parameters for the PG Biartite Graph
     */
    refinement1( PG_parameters );

    /* REFINEMENT 2 - STRUCTURAL REFINEMENT
     * This is a necessary refinement to build the VHDL Modules
     */
    refinement2( PG_parameters );

    /* REFINEMENT 4 - GENERATING VHDL MODULES
     * We will use the parameters generated till here and the
     * and the partitioned HDL files to make all the VHDL
     * Modules for this PG Bipartite Graph
     */
    write_vhdl_modules( PG_parameters );

    return 0;
}

